// first.cpp : Defines the entry point for the application.
//

#include "ownet.h"
#include "resource.h"
#include <commctrl.h>
#include <windows.h>
#include <windowsx.h>

// globals for TMEX functions
long session_handle;
unsigned char state_buffer[5120];
short PortNum=1,PortType;  // default COM1
short didsetup=0;
TCHAR outbuf[400];

HINSTANCE hInst = NULL;
HWND hwndMain = NULL, hwndCB = NULL;

TCHAR szAppName[9];
TCHAR szTitle[40];

BOOL InitApplication(HINSTANCE hInstance);
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow);
LRESULT CALLBACK WndProc(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp);


int
WINAPI
WinMain(HINSTANCE hInstance,
		HINSTANCE hPrevInstance, 
		LPWSTR    lpCmdLine,
		int       nCmdShow)
/*---------------------------------------------------------------------------*\
 * 
\*---------------------------------------------------------------------------*/
{
	MSG msg;

	InitCommonControls();

	if (!hPrevInstance) {
        if (!InitApplication(hInstance)) {
            return FALSE;
        }
    }

    if (!InitInstance(hInstance, nCmdShow)) {
        return FALSE;
    }


	while (GetMessage(&msg, NULL, 0, 0)) {
		if (!IsCommandBarMessage(hwndCB, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	
	return msg.wParam;

} /* WinMain()
   */


BOOL InitApplication(HINSTANCE hInstance)
/*---------------------------------------------------------------------------*\
 * 
\*---------------------------------------------------------------------------*/
{
	WNDCLASS wc;

   
    LoadString(hInstance, IDS_APPNAME, szAppName, sizeof(szAppName));
    LoadString(hInstance, IDS_DESCRIPTION, szTitle, sizeof(szTitle));
	wc.style         = CS_HREDRAW | CS_VREDRAW; // Class style(s).
    wc.lpfnWndProc   = (WNDPROC)WndProc;        // Window Procedure
    wc.cbClsExtra    = 0;                       // No per-class extra data.
    wc.cbWndExtra    = 0;                       // No per-window extra data.
    wc.hInstance     = hInstance;               // Owner of this class
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPICON));
#ifdef TARGET_NT
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
#endif
	wc.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
	wc.lpszMenuName  = NULL;               // Menu name from .RC
    wc.lpszClassName = szAppName;               // Name to register as

	return RegisterClass(&wc);

} /* InitApplication()
   */


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
/*---------------------------------------------------------------------------*\
 * 
\*---------------------------------------------------------------------------*/
{
	hInst = hInstance;
#ifdef TARGET_NT
	hwndMain = CreateWindow(szAppName, szTitle, 
		                    WS_POPUP,
	                     	0, 0,
							CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL,
							hInstance, NULL);
#else
		hwndMain = CreateWindow(szAppName, szTitle, 
		                    WS_VISIBLE,
	                     	0, 0,
							CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL,
							hInstance, NULL);
#endif

	if (!hwndMain) {
        return FALSE;
	}

   ShowWindow(hwndMain, nCmdShow);
	UpdateWindow(hwndMain);	

	return TRUE;
	
} /* InitInstance()
   */


BOOL CreateCommandBar(HWND hwnd)
/*---------------------------------------------------------------------------*\
 * 
\*---------------------------------------------------------------------------*/
{
	HICON hIcon;

	// NOTE: We need to register the 16x16 icon so that it will display
	//       properly on the Pegasus taskbar.	
	hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_APPICON),
							 IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	SendMessage(hwnd, WM_SETICON, FALSE, (WPARAM)hIcon);


	// NOTE: First we need to create the command bar
	if (hwndCB = CommandBar_Create(hInst, hwnd, 1)) {

		// NOTE: Now add some strings to be displayed on the buttons	
		SendMessage(hwndCB, TB_ADDSTRING, (WPARAM)hInst,
					MAKELONG(IDS_NEW,  0));
		SendMessage(hwndCB, TB_ADDSTRING, (WPARAM)hInst,
					MAKELONG(IDS_OPEN, 0));

		// NOTE: Add the bitmaps we want to use.
		CommandBar_AddBitmap(hwndCB, HINST_COMMCTRL, IDB_STD_SMALL_COLOR,
							 15, 16, 16);
		
		// NOTE: Add the menu that we will have for our application.
		CommandBar_InsertMenubar(hwndCB, hInst, IDM_MAIN_MENU, 0);

		// NOTE: Finally add the exit and help button adornments
		CommandBar_AddAdornments(hwndCB, STD_HELP, IDM_EXIT);
	}
	
	return (hwndCB != NULL);

} /* CreateCommandBar()
   */


LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
/*---------------------------------------------------------------------------*\
 * 
\*---------------------------------------------------------------------------*/
{
	PAINTSTRUCT ps;
	HDC hdc;
   short cnt,buflen = 0;
   RECT rect;
   int rslt;
   uchar sn[8];

	switch (msg) {
		case WM_CREATE:
			CreateCommandBar(hwnd);
         // start the idle timer
         SetTimer(hwnd,1,100,NULL);

			break;

		case WM_PAINT:
         // update the display
         hdc = BeginPaint(hwnd, &ps);

         GetClientRect(hwnd, &rect);
         rect.top += CommandBar_Height(hwndCB);
         DrawText(hdc,TEXT("           iButton Public Domain Search           "), -1, &rect,
                  DT_SINGLELINE | DT_CENTER | DT_TOP);
         rect.top += CommandBar_Height(hwndCB);
         rect.left = (rect.right - rect.left) / 3;
         DrawText(hdc,outbuf, -1, &rect,
                 DT_WORDBREAK | DT_LEFT | DT_TOP);

         EndPaint(hwnd, &ps);
         break;
			
		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wp,lp))
			{
				case IDC_NONE:
					break;
					
				case IDM_EXIT:
               // close the app
					SendMessage(hwnd, WM_CLOSE, 0, 0);
					break;

            default:
					return DefWindowProc(hwnd, msg, wp, lp);
			}
			break;

		case WM_CLOSE:
         // remove the timer
         KillTimer(hwnd,1);

         DestroyWindow(hwnd);
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_TIMER:    
         if (owAcquire(PortNum,"0"))
         {
            cnt = 0;

            // find the first device (all devices not just alarming)
            rslt = owFirst(PortNum, TRUE, FALSE);
            	
            while (rslt)
            {
               // print the device number
               cnt++;

               // print the Serial Number of the device just found
               owSerialNum(PortNum,sn,TRUE);

               buflen += wsprintf(&outbuf[buflen],
                              TEXT("ROM:  %02X%02X%02X%02X%02X%02X%02X%02X \n"),
                              sn[7],sn[6],sn[5],sn[4],
                              sn[3],sn[2],sn[1],sn[0]);

               // find the next device
               rslt = owNext(PortNum, TRUE, FALSE);
            }
   
            // release the 1-Wire Net	  
            owRelease(PortNum);
         }

         GetClientRect(hwnd,&rect);
         InvalidateRect(hwnd,&rect,TRUE);
         UpdateWindow(hwnd);

         break;

		default:
			return DefWindowProc(hwnd, msg, wp, lp);
	}

	return 0;
		
} /* WndProc()
   */
